#include "ec801.h"
#include "stdio.h"
#include "string.h"
#include "sdfunc.h"
#include "app_cat1.h"
#include "wm_gpio_afsel.h"
#include <string.h>
#include "app_Md5.h"
#include "cJSON.h"

#define pd4GMS_TO_TICKS( xTimeInMs )    ( ( uint32_t ) ( ( ( uint32_t ) ( xTimeInMs ) * ( uint32_t ) /*configTICK_RATE_HZ*/HZ ) / ( uint32_t ) 1000U ) )

M4G_FSM_t hM4G_FSM;
AppEc801_t g_tAppEc801 = {0};
uint32_t m4gRestartTime  = 5000;   //5룬ÿε20
uint32_t gM4gr_recv_tout = 10000;  //ϵȴظϢ2
#define ConnectTick        60000   //Ӻ1
#define DBG_RX_BUF_SIZE 32
#define DBG_TX_BUF_SIZE 320
char    g_DBG_ascBuf[DBG_TX_BUF_SIZE * 2];

#define ETH_BUF_TX_SIZE    256
#define ETH_BUF_RX_SIZE    1024

uint8_t g_M4GserMode = 0;//ģжdnsipֱı

#define DEMO_UART_TAST_STK_SIZE	3072
#define DEMO_UART_RX_BUF_SIZE	1024
static OS_STK   demo_uart_task_stk[DEMO_UART_TAST_STK_SIZE];


uint8_t  g_ETH_UartRxBuf[ETH_BUF_RX_SIZE];
uint8_t  g_ETH_UartTxBuf[ETH_BUF_TX_SIZE];

BspUart_t M4G_UART = 
{
    .huart   = TLS_UART_3,
    .rxSize  = ETH_BUF_RX_SIZE,
    .txSize  = ETH_BUF_TX_SIZE,
    .pRxBuf  = g_ETH_UartRxBuf,
    .pTxBuf  = g_ETH_UartTxBuf,
    .txStat  = UART_TX_STATE_IDLE,
};

#define huartx M4G_UART


BspGpio_t hgpio1 =
{
    .gpio_num = WM_IO_PB_05,
    .gpio_state = GPIO_PIN_RESET,
    .gpio_attr = WM_GPIO_ATTR_FLOATING,
};

//һź
tls_os_sem_t * sem_rx = NULL;
// 洢յݵĳ
u16 rx_length = 0;
u8 rx_fifo_buf[1024] = {0};

static u8_t rx_flag = 0;
/*****************************************************************************
*    : M4G_UartHandle_Init
* ˵ : CAT1 ڳʼ 
*            *ͨ BSP_UART_LinkHandle ӵBSPӣȻ쳣
*      : 
*   ֵ : 
*****************************************************************************/

/**
 * @brief M4G ڳʼ 
 *        !ͨ BSP_UART_LinkHandle ӵBSPӣȻ쳣
 * 
 */
static void M4G_UartHandle_Init(void)
{
    //!ĻƾӵBSP
    BSP_UART_LinkHandle(&huartx);
}


static void M4G_UART_Transmit(uint8_t *pData, uint16_t Size)
{
    BSP_UART_Transmit_IT(&huartx, pData, Size);
}

#define m4g_printf(fmt, ...) \
    do { \
        __IO int len; \
        len = snprintf((char *)huartx.pTxBuf, huartx.txSize, fmt, ##__VA_ARGS__); \
        M4G_UART_Transmit(huartx.pTxBuf, len); \
        printf("Tx_Cmd:%s\r\n", huartx.pTxBuf); \
        UNUSED(len); \
    }while(0) 


const ATCMD_str M4G_CMD_LIST[] = 
{
    //{AT_RESET             ,"AT+RESET\r\n"         ,"RDY"          ,"λ"         ,20000  ,1},
    /* AT+RESETḴλʼãAT&FҲʼPDP*/
                                                                                        //Ӧ
    //              ָ            ȷֵ                                  ʱʱ    ط 

    //ָ
    //[AT_POWDOWN ] = { "AT+QPOWD\r\n"     ,"POW"       ,""                            ,1000       , 1},
    [AT_DELAY     ] = { ""                 ,"RDY"       ,"Ѿ"                          ,120000     , 1},
    //
    [AT_TEST      ] = { "AT\r\n"           ,"OK"        ,""                        ,3000       , 5},
    [AT_ATE0      ] = { "ATE0\r\n"         ,"OK"        ,"ѡǻ"                      ,1000       , 5},
    [AT_CGSN      ] = { "AT+CGSN\r\n"      ,"OK"        ,"ѯIMEI"                      ,1000       , 3},
    [AT_CSQ       ] = { "AT+CSQ\r\n"       ,"OK"        ,"ȡźǿ"                    ,3000       ,20}, //99źǿδ֪ǿȣز,زΪ20κ
    [AT_CPIN      ] = { "AT+CPIN?\r\n"     ,"READY"     ,"SIMǷҪԿ"               ,3000       ,30}, //ready˵ҪsimѾ
    [AT_CREG      ] = { "AT+CREG?\r\n"     ,"0,1"       ,"ѯע״̬"                ,1000       , 3},
    [AT_CGATT     ] = { "AT+CGATT?\r\n"    ,": 1"       ,"⼤PDP"                     ,1000       , 3},
    [AT_QIDEACT   ] = { "AT+QIDEACT=1\r\n" ,"OK"        ,"ȥ"                    ,3000       , 3},
    [AT_QIACT     ] = { "AT+QIACT=1\r\n"   ,"OK"        ,""                      ,150000     , 1},
    [AT_DNS_ANALY ] = { "AT+QIDNSGIP="     ,"dnsgip"    ,"DNS"                     ,3000       , 3},

    [AT_DESTROY   ] = { "+++"              ,"OK"        ,"Ͽ͸ģʽ"                    ,3000       , 1}, //лBuffģʽ
    [AT_QICLOSE_ID] = { "AT+QICLOSE=0\r\n" ,"OK"        ,"رSocket"                  ,3000       , 1},
    [AT_QIDEACT_ID] = { "AT+QIDEACT=1\r\n" ,"OK"        ,"ȥPDP"                       ,3000       , 1},
    /*HTTPS*/
    [AT_QHTTPCFG ] = { "AT+QHTTPCFG="      ,"OK"        ,"HTTP(S)"           ,3000       , 1},
    // [AT_QSSLCFG  ] = { "AT+QSSLCFG="       ,"OK"        ,"SSLĲ"               ,3000       , 1},
    [AT_QHTTPURL ] = { "AT+QHTTPURL="      ,"ECT"       ,"HTTP(S)URL"            ,3000       , 1},
    [AT_QHTTPCONN] = { ""                  ,"OK"        ,"HTTP(S)"           ,3000       , 1},
    [AT_QHTTPGET ] = { "AT+QHTTPGET="      ,"200"       ," GET  HTTP(S)"   ,3000       , 1},
    [AT_QHTTPREAD] = { "AT+QHTTPREAD="     ,"true"      ,"ȡ HTTP(S)ӦϢ"      ,3000       , 1},
    /*MQTT*/    
    [AT_QMTOPEN   ] = { "AT+QMTOPEN="      ,",0"        ,"MQTT"                    ,5000        ,3},
    [AT_QMTCONN   ] = { "AT+QMTCONN="      ,",0"        ,"MQTTӷ"                  ,5000        ,3},
    [AT_QMTPUBEX  ] = { "AT+QMTPUBEX="     ,">"         ,"MQTT"                    ,5000        ,3},
    [AT_MQTT_TX   ] = { ""                 ,",0"        ,"MQTT"                    ,5000        ,3},
    [AT_QMTDISC   ] = { "AT+QMTDISC=0"     ,",0"        ,"MQTTϿ"                    ,5000        ,3},

    [AT_OPEN_ID   ] = { "AT+QIOPEN="       ,"CONNECT"   ,"Socket"                  ,5000        ,3},
    [AT_DEOPEN    ] = { ""                 ,"NO CARRIER","Ͽ"                  ,60000       ,3},

    // [AT_CGPADDR_ID] = { "AT+CGPADDR="      ,"OK"           ,"ȡIPַ"       ,1000       ,3}, //ıIP
    // [AT_QICSGP_ID ] = { "AT+QICSGP="       ,"OK"           ,"PDP"      ,1000       ,3}, //ȷȷ
    // [AT_QIACT_ID  ] = { "AT+QIACT="        ,"OK"           ,"PDP"      ,3000       ,3}, //򷵻ERROR
    // [AT_QISTATE   ] = { "AT+QISTATE?\r\n"  ,"+QISTATE: 0"  ,"ѯ״̬"     ,1000       ,3},

};    

static void M4G_FSM_Init(void)
{
    hM4G_FSM.eCurrStat = M4G_STAT_CONNECT_RESTART;
    hM4G_FSM.TxRxStat  = TX_RX_STAT_IDLE;
    hM4G_FSM.tickStart = tls_os_get_time();
    hM4G_FSM.txStep    = AT_TEST; //ATʼ 0Ϊ
    hM4G_FSM.retryCnt  = M4G_CMD_LIST[hM4G_FSM.txStep].retryNum;
    hM4G_FSM.rxTimeout = M4G_CMD_LIST[hM4G_FSM.txStep].TimeOut;
    hM4G_FSM.eTimeStat = TimeOut_OFF;
    hM4G_FSM.stepCnt   = 0;
    hM4G_FSM.sendCnt   = 0;
    g_tAppEc801.csq    = 99;

    //ǿ
    //lockIF_SetOption(0, eCHG_IF_NET_CSQ, &g_tAppEc600.csq, 1);//ȫݹcsq
}

static void M4G_AT_CMD_Send(uint8_t idx)
{
    M4G_UART_Transmit((uint8_t *)M4G_CMD_LIST[idx].pATSendStr, strlen(M4G_CMD_LIST[idx].pATSendStr));
}


static uint8_t M4G_AT_CMD_Recv(uint8_t idx)//ģҪԶнд
{
    void *msg;
    int ret = 0;
    int len = 0;
    int rx_len = 0;

    tls_os_queue_receive(huartx.demo_uart_q, (void **) &msg, 0, 0);
    printf("111");
    switch ((u32) msg)
    {
        case DEMO_MSG_UART_RECEIVE_DATA:
        rx_len = huartx.rx_data_len;
        while (rx_len > 0)
        {
            len = (rx_len > DEMO_UART_RX_BUF_SIZE) ? DEMO_UART_RX_BUF_SIZE : rx_len;
            memset(huartx.pRxBuf, 0, (DEMO_UART_RX_BUF_SIZE + 1));
            ret = tls_uart_read(TLS_UART_3, (u8 *) huartx.pRxBuf, len);  /* input */
            if (ret <= 0)
            {
                break;
            }

            rx_len -= ret;
            huartx.rx_data_len -= ret;
            
            if(hM4G_FSM.eCurrStat != M4G_STAT_DATA_PASS_THROUGH)
                {
                    printf("RX_Cmd:%s\r\n", M4G_UART.pRxBuf);
                }
                    /**
                 * @note ۲쵽 ͸ģʽʱģԴӴ δ˳͸״̬Ҵڵ¼CMD 01״̬£
                 * ģ쳣ظAܵģ鿨״̬
                */
                else
                {
                    if((strcmp((char*)M4G_UART.pRxBuf,"A") == 0) || (strcmp((char*)M4G_UART.pRxBuf,"\r\nRDY\r\n") == 0))
                    {
                        printf("RX_Cmd:%s\r\n", M4G_UART.pRxBuf);
                        rx_flag = 0;
                        rx_length = 0;
                        return 1;
                    }
                }
                if((strstr((char*)M4G_UART.pRxBuf, M4G_CMD_LIST[idx].pATRecStr) != NULL))
                {
                    printf("MATCH SUCCESS\r\n");
                    rx_flag = 0;
                    rx_length = 0;
                    return 1;
                }
        }
        break;
    }

    // if(os_status) 
    // {
    //     if(rx_length > 0) 
    //     {				
    //         if(rx_length < ETH_BUF_RX_SIZE)// 4Gʱ󷢼ֽڵݣжϻʹuartĽԽʵmcu
    //         {
    //             rx_len = tls_uart_read(M4G_UART.huart, M4G_UART.pRxBuf, rx_length);
    //         }
    //         printf("RXFLAG:%d\r\n" , rx_flag);
    //         if (rx_flag == 1)
    //         {
    //             // tls_os_sem_release(sem_rx);  // ? ʱͷź
    //             printf("lenth:%d; char: %s\n",rx_length, M4G_UART.pRxBuf);
                
    //             if(hM4G_FSM.eCurrStat != M4G_STAT_DATA_PASS_THROUGH)
    //             {
    //                 printf("RX_Cmd:%s\r\n", M4G_UART.pRxBuf);
    //             }
    //                 /**
    //              * @note ۲쵽 ͸ģʽʱģԴӴ δ˳͸״̬Ҵڵ¼CMD 01״̬£
    //              * ģ쳣ظAܵģ鿨״̬
    //             */
    //             else
    //             {
    //                 if((strcmp((char*)M4G_UART.pRxBuf,"A") == 0) || (strcmp((char*)M4G_UART.pRxBuf,"\r\nRDY\r\n") == 0))
    //                 {
    //                     printf("RX_Cmd:%s\r\n", M4G_UART.pRxBuf);
    //                     rx_flag = 0;
    //                     rx_length = 0;
    //                     return 1;
    //                 }
    //             }
    //             if((strstr((char*)M4G_UART.pRxBuf, M4G_CMD_LIST[idx].pATRecStr) != NULL))
    //             {
    //                 printf("MATCH SUCCESS\r\n");
    //                 rx_flag = 0;
    //                 rx_length = 0;
    //                 return 1;
    //             }
    //             rx_flag = 0;
    //             // memset(M4G_UART.pRxBuf, 0, sizeof((char*)M4G_UART.pRxBuf));
    //         }
    //         printf("RXFLAG:%d\r\n" , rx_flag);
    //         rx_length = 0;
            
    //     }
            
    //     // }
    // } 
    return 0;
	
}


static void TCP_SVR_FSM_Init(void)
{
    ;
}

static void TCP_SVR_FSM_Handler(void)
{
    ;
}

static void TCP_SVR_SendHandler(void)
{
    ;
}

static void TCP_SVR_RecvHandler(void)
{
    ;
}


/***********************************ӣMQTT OR HTTPSFUNC START*****************************************/
/*****************************************************************************
       :  HTTP_QHTTPCFG
    ˵ :  cat.1HTTP(S)
         :  cfg:Ŀ
                enableò
      ֵ :  
    ޸ļ¼ :
        汾             ˵
        V1.0.0  2025-3-8   YXL   
*****************************************************************************/
static void HTTP_QHTTPCFG(char *cfg, uint8_t enable)
{
    m4g_printf("AT+QHTTPCFG=\"%s\",%d\r\n", cfg, enable);
}

/*****************************************************************************
       :  HTTP_QSSLCFG
    ˵ :  cat.1ssl
         :  cfg:Ŀ
                
      ֵ :  
    ޸ļ¼ :
        汾             ˵
        V1.0.0  2025-3-8   YXL   
*****************************************************************************/
static void HTTP_QSSLCFG(char *cfg, uint8_t SSL_ctxID, uint16_t sel)
{
    m4g_printf("AT+QSSLCFG=\"%s\",%d,%d\r\n", cfg, SSL_ctxID, sel);
}
/*************************************************************************************
       :  HTTP_Acive
    ˵ :  http¼ﵽtimeoutյURLСURL_lengtherr
         :  url_length:ַ
                timeout:ʱʱ
      ֵ :  
    ޸ļ¼ :
        汾             ˵
        V1.0.0  2025-3-10  YXL   
***************************************************************************************/
static void HTTP_ACTIVE(uint16_t url_length, uint8_t timeout)
{
    m4g_printf("AT+QHTTPURL=%d,%d\r\n", url_length, timeout);
}

/*************************************************************************************
       :  HTTP_GET
    ˵ :  httpGET
         :  
                timeout:ʱʱ
      ֵ :  
    ޸ļ¼ :
        汾             ˵
        V1.0.0  2025-3-10  YXL   
***************************************************************************************/
static void HTTP_GET(uint8_t timeout)
{
    m4g_printf("AT+QHTTPGET=%d\r\n", timeout);
}

/*************************************************************************************
       :  HTTP_READ
    ˵ :  httpȡϢ
         :  
                timeout:ʱʱ
      ֵ :  
    ޸ļ¼ :
        汾             ˵
        V1.0.0  2025-3-10  YXL   
***************************************************************************************/
static void HTTP_READ(uint8_t timeout)
{
    m4g_printf("AT+QHTTPREAD=%d\r\n", timeout);
}
/*****************************************************************************
       :  MQTT_Open_Step
    ˵ :  cat.1MQTTӷҪȴMQTT
         :  clientIDxMQTTͻ˱ʶһΪ0
                hostַΪIPַ
                portMQTT˿ںţĬ1883
      ֵ :  
    ޸ļ¼ :
        汾             ˵
        V1.0.0  2025-3-7  YXL   
*****************************************************************************/
static void MQTT_Open_Step(uint8_t clientIDx,char *host, uint16_t port)
{
    m4g_printf("AT+QMTOPEN=%d,\"%s\",%d\r\n", clientIDx, host, port);
}

/*****************************************************************************
       :  MQTT_Establish_Step
    ˵ :  cat.1MQTTӷ
         :  clientIDxMQTTͻ˱ʶһΪ0
                clientID MQTTԪClientid
                username MQTTԪUsername
                pwd      MQTTԪPassword
      ֵ :  
    ޸ļ¼ :
        汾             ˵
        V1.0.0  2025-3-7   YXL   
*****************************************************************************/
static void MQTT_Establish_Step(uint8_t clientIDx, char *clientID,char *username, char *pwd)
{
    m4g_printf("AT+QMTCONN=%d,\"%s\",\"%s\",\"%s\"\r\n",clientIDx, clientID, username, pwd);
}

/*****************************************************************************
       :  MQTT_Qmtpubex_Step
    ˵ :  cat.1MQTT
         :  clientIDxMQTTͻ˱ʶһΪ0
                msgID    ݰϢʶΧ0~65535.ֻеqos=0ʱòֵΪ0
                qos      MQTTqosȼƽ̨Ҫ豸ϢͳһQOS1
                retain   Ϣ͵ǰߺ󣬷Ƿ񱣴Ϣ 0 1
                topic    Ϣ
                length   Ϣݳ
      ֵ :  
    ޸ļ¼ :
        汾             ˵
        V1.0.0  2025-3-7   YXL   
*****************************************************************************/
static void MQTT_Qmtpubex_Step(uint8_t clientIDx, uint8_t msgID, uint8_t qos, uint8_t retain, char *topic, uint16_t length)
{
    m4g_printf("AT+QMTPUBEX=%d,%d,%d,%d,\"%s\",%d\r\n",clientIDx, msgID, qos, retain, topic, length);
}
static void TCP_Establish_Step(uint8_t connectID,char *host, uint16_t port)
{
    m4g_printf("AT+QIOPEN=1,%d,\"TCP\",\"%s\",%d,0,2\r\n",connectID,host,port);
}


static void DNS_Analysish_Step(char *host)
{
    m4g_printf("AT+QIDNSGIP=1,\"%s\"\r\n",host);
}
/***********************************ӣMQTT OR HTTPSFUNC END*****************************************/

/****************************************4G FSM FUNC START***************************************************/
static void M4G_FSM_RestartConnect(void)
{
    uint32_t currTick = tls_os_get_time();
    if((currTick - hM4G_FSM.tickStart) >= pd4GMS_TO_TICKS(m4gRestartTime)) //ʮģرʱ,
    {
        /* ʱӳ,ʱΪ5 */
        if((hM4G_FSM.eTimeStat == TimeOut_ON) && (m4gRestartTime < pd4GMS_TO_TICKS(300000)))
        {
            m4gRestartTime += 20000;
        }
        printf("Power ON -> Next PowerOffTime : %lds\r\n",(long)(m4gRestartTime/1000));
        BSP_GPIO_Output_ON(&hgpio1);
        hM4G_FSM.eCurrStat = M4G_STAT_CONNECT_START;
        hM4G_FSM.tickStart = tls_os_get_time();
    }
}

//FSM RDY׼̬
static void M4G_FSM_StartConnect(void)
{
    uint32_t currTick = tls_os_get_time();
    if(M4G_AT_CMD_Recv(AT_DELAY) == 1) //ܵRDY
    {
        //״̬ת
        hM4G_FSM.TxRxStat  = TX_RX_STAT_IDLE;
        hM4G_FSM.txStep    = AT_TEST;  //л
        hM4G_FSM.eCurrStat = M4G_STAT_CONNECT_BASE_STATION;
        hM4G_FSM.retryCnt  = M4G_CMD_LIST[hM4G_FSM.txStep].retryNum;
        hM4G_FSM.rxTimeout = M4G_CMD_LIST[hM4G_FSM.txStep].TimeOut;
        hM4G_FSM.eTimeStat = TimeOut_OFF;
		
    }
    else if((currTick - hM4G_FSM.tickStart) >= pd4GMS_TO_TICKS(gM4gr_recv_tout)) //ʱδRDY ֱ
    {
        hM4G_FSM.TxRxStat  = TX_RX_STAT_IDLE;
        hM4G_FSM.txStep    = AT_TEST;  //л
        hM4G_FSM.eCurrStat = M4G_STAT_CONNECT_BASE_STATION;
        hM4G_FSM.retryCnt  = M4G_CMD_LIST[hM4G_FSM.txStep].retryNum;
        hM4G_FSM.rxTimeout = M4G_CMD_LIST[hM4G_FSM.txStep].TimeOut;
        hM4G_FSM.eTimeStat = TimeOut_OFF;
    }
}

//FSM ƽ̨ǰ׼̬
static uint8_t M4G_FSM_ConnectBaseStation(void)
{
    uint8_t csq = 0;
    uint32_t currTick = tls_os_get_time();

    if(hM4G_FSM.TxRxStat == TX_RX_STAT_IDLE)
    {
        if(hM4G_FSM.retryCnt == 0)
        {
            hM4G_FSM.endStep = AT_QIACT;
            if(hM4G_FSM.eTimeStat == TimeOut_ON)
            {
                hM4G_FSM.stepCnt = 0;
                hM4G_FSM.sendCnt = 0;
                printf("Time Out -> Power OFF\r\n");
                NET_M4G_Reset();    //ʱδظģ磬³ʼ
                hM4G_FSM.eTimeStat = TimeOut_ON;
                /* ״̬ת */
                hM4G_FSM.eCurrStat = M4G_STAT_CONNECT_RESTART;
                return 0;

            }
            if(++hM4G_FSM.txStep > hM4G_FSM.endStep) //״̬
            {
                __OS_SHM_LOCK();
                csq = g_tAppEc801.csq;
                
                __OS_SHM_UNLOCK();
                if(hM4G_FSM.stepCnt == (hM4G_FSM.endStep - AT_TEST+1) && csq > 1 && csq != 99) //ۼƴ
                {
                    hM4G_FSM.stepCnt = 0;
                    hM4G_FSM.txStep = AT_QHTTPCFG;
                    //״̬ת
                    hM4G_FSM.eCurrStat = M4G_STAT_HTTPS_CFG ;
                    hM4G_FSM.retryCnt  = M4G_CMD_LIST[hM4G_FSM.txStep].retryNum;
                    hM4G_FSM.rxTimeout = M4G_CMD_LIST[hM4G_FSM.txStep].TimeOut;
                    return 0;
                }
                else
                {
                    hM4G_FSM.stepCnt = 0;
                    hM4G_FSM.sendCnt = 0;
                    printf("Time Out -> Power OFF\r\n");
                    NET_M4G_Reset();    //źŲѾظSendCntMaxΣģ磬³ʼ
                    //hM4G_FSM.txStep = AT_POWDOWN;
                    //״̬ת
                    hM4G_FSM.eCurrStat = M4G_STAT_CONNECT_RESTART;
                    return 0;
                }
            }

           
            hM4G_FSM.retryCnt  = M4G_CMD_LIST[hM4G_FSM.txStep].retryNum;
            hM4G_FSM.rxTimeout = M4G_CMD_LIST[hM4G_FSM.txStep].TimeOut;
        }
        M4G_AT_CMD_Send(hM4G_FSM.txStep);

        if(hM4G_FSM.txStep != AT_DNS_ANALY)
		{
			printf("Tx_Cmd:%s",M4G_CMD_LIST[hM4G_FSM.txStep].pATSendStr);
		}
        hM4G_FSM.TxRxStat  = TX_RX_STAT_BUSY;
        hM4G_FSM.tickStart = tls_os_get_time();
    }
    else
    {
        if(M4G_AT_CMD_Recv(hM4G_FSM.txStep) == 1)
        {
            if(hM4G_FSM.txStep == AT_CSQ)
            {
                M4G_GetSignalStrength();
                __OS_SHM_LOCK();
                csq = g_tAppEc801.csq;
                __OS_SHM_UNLOCK();
                if(csq == 99) //źǿΪδ֪99˳ܳɹ
                {
                    /* ֱźΪֹ */
                    // hM4G_FSM.retryCnt = 5;
					printf("CSQ:%d\r\n",csq);
					hM4G_FSM.eCurrStat = M4G_STAT_CONNECT_RESTART;
                    return 0;
                }
            }
            
//            if(hM4G_FSM.txStep == AT_DNS_ANALY)
//            {
//                M4G_GetIPAddress();
//            }
            hM4G_FSM.TxRxStat = TX_RX_STAT_IDLE;
            /* յָݣһν Դ */
            hM4G_FSM.retryCnt = 0;
            hM4G_FSM.eTimeStat = TimeOut_OFF;
            hM4G_FSM.stepCnt++;
        }
        else if((currTick - hM4G_FSM.tickStart) >= pd4GMS_TO_TICKS(hM4G_FSM.rxTimeout) )
        {
            hM4G_FSM.TxRxStat = TX_RX_STAT_IDLE;
            /* ճʱԴһ */
            if(--hM4G_FSM.retryCnt == 0)
            {
                hM4G_FSM.eTimeStat = TimeOut_ON;
            }
        }
    }
    return 0;
}


static void M4G_HTTPS_CFG_SEND(uint8_t cfgstep)
{
    char qhttpcfg[6][32] = {"contextid","sslctxid","sslversion","ciphersuite","seclevel","sni"};
    if(cfgstep > 1)
    {
        switch(cfgstep)
        {
            case 2:
                HTTP_QSSLCFG(qhttpcfg[cfgstep], 1, 4);
                break;
            case 3:
                HTTP_QSSLCFG(qhttpcfg[cfgstep], 1, 0XFFFF);
                break;
            case 4:
                HTTP_QSSLCFG(qhttpcfg[cfgstep], 1, 0);
                break;
            case 5:
                HTTP_QSSLCFG(qhttpcfg[cfgstep], 1, 1);  // ƶ˵ķһ㶼Ҫsni
                break;
        }
    }
    else
    {
        HTTP_QHTTPCFG(qhttpcfg[cfgstep], 1);
    }           
}


static uint8_t M4G_FSM_ConnectHTTPSCfg(void)
{
    const uint8_t cfgmaxstep = 6;
    static uint8_t cfgstep = 0;
    uint32_t currTick = tls_os_get_time();
    if(hM4G_FSM.TxRxStat == TX_RX_STAT_IDLE)
    {
        if(hM4G_FSM.retryCnt == 0)
        {
            if(++cfgstep > cfgmaxstep) //״̬
            {
                cfgstep = 0;
                hM4G_FSM.stepCnt = 0;
                hM4G_FSM.txStep = AT_QHTTPURL;
                //״̬ת
                hM4G_FSM.eCurrStat = M4G_STAT_HTTPS_ACTIVE ;
                hM4G_FSM.retryCnt  = M4G_CMD_LIST[hM4G_FSM.txStep].retryNum;
                hM4G_FSM.rxTimeout = M4G_CMD_LIST[hM4G_FSM.txStep].TimeOut;
                return 0;         
            }
            if(hM4G_FSM.eTimeStat == TimeOut_ON)
            {
                hM4G_FSM.stepCnt = 0;
                hM4G_FSM.sendCnt = 0;
                printf("Time Out -> Power OFF\r\n");
                NET_M4G_Reset();    //ʱδظģ磬³ʼ
                hM4G_FSM.eTimeStat = TimeOut_ON;
                /* ״̬ת */
                cfgstep = 0;
                hM4G_FSM.eCurrStat = M4G_STAT_CONNECT_RESTART;
                return 0;
            }
            hM4G_FSM.retryCnt  = M4G_CMD_LIST[hM4G_FSM.txStep].retryNum;
            hM4G_FSM.rxTimeout = M4G_CMD_LIST[hM4G_FSM.txStep].TimeOut;
        }
        M4G_HTTPS_CFG_SEND(cfgstep);
        // printf("Tx_Cmd:%s",M4G_CMD_LIST[hM4G_FSM.txStep].pATSendStr);
        hM4G_FSM.TxRxStat  = TX_RX_STAT_BUSY;
        hM4G_FSM.tickStart = tls_os_get_time();
    }
    else
    {
        if(M4G_AT_CMD_Recv(hM4G_FSM.txStep) == 1)
        {
            hM4G_FSM.TxRxStat = TX_RX_STAT_IDLE;
            /* յָݣһν Դ */
            hM4G_FSM.retryCnt = 0;
            hM4G_FSM.eTimeStat = TimeOut_OFF;
        }
        else if((currTick - hM4G_FSM.tickStart) >= pd4GMS_TO_TICKS(hM4G_FSM.rxTimeout) )
        {
            hM4G_FSM.TxRxStat = TX_RX_STAT_IDLE;
            /* ճʱԴһ */
            if(--hM4G_FSM.retryCnt == 0)
            {
                hM4G_FSM.eTimeStat = TimeOut_ON;
            }
        }
    }
    return 0;
}

static uint8_t  M4G_FSM_M4G_HTTPS_ACTIVE (void)
{   
    ;
}








// //FSM ƽ̨
// static void M4G_FSM_ConnectPlatform(void)
// {
//     uint32_t currTick = tls_os_get_time();
//     if(hM4G_FSM.TxRxStat == TX_RX_STAT_IDLE)
//     {
//         if(hM4G_FSM.retryCnt == 0)
//         {
//             if(hM4G_FSM.eTimeStat == TimeOut_ON) //һֱ޷
//             {
//                 hM4G_FSM.txStep = AT_DESTROY;
//                 //״̬ת
//                 hM4G_FSM.eCurrStat = M4G_STAT_DATA_BREAK_THROUGH;
//                 hM4G_FSM.retryCnt  = M4G_CMD_LIST[hM4G_FSM.txStep].retryNum;
//                 hM4G_FSM.rxTimeout = M4G_CMD_LIST[hM4G_FSM.txStep].TimeOut;
//             }
//             /* װԴͳʱʱ */
//             hM4G_FSM.retryCnt  = M4G_CMD_LIST[hM4G_FSM.txStep].retryNum;
//             hM4G_FSM.rxTimeout = M4G_CMD_LIST[hM4G_FSM.txStep].TimeOut;
//         }
//         EC600_Connet_TCP(); //OPEN

//         hM4G_FSM.TxRxStat  = TX_RX_STAT_BUSY;
//         hM4G_FSM.tickStart = tls_os_get_time();
//     }
//     else
//     {
//         if(M4G_AT_CMD_Recv(hM4G_FSM.txStep) == 1)
//         {
//             // netIF_SetOption_SvrState(1);
//             hM4G_FSM.TxRxStat = TX_RX_STAT_IDLE;
//             /* յָݣһν Դ */
//             hM4G_FSM.retryCnt = 0;
//             /* ƽ̨ӳɹжģʱ */
//             m4gRestartTime = 5000;
//             /* лһ͸״̬ */
//             hM4G_FSM.eCurrStat = M4G_STAT_DATA_PASS_THROUGH;
//             /* ʼһ״̬Ľܱʶ */
//             huartx.rxFlag = 0;
//             TCP_SVR_FSM_Init();
//         }
//         else if((currTick - hM4G_FSM.tickStart) >= pd4GMS_TO_TICKS(hM4G_FSM.rxTimeout))
//         {
//             hM4G_FSM.TxRxStat = TX_RX_STAT_IDLE;
//             /* ճʱԴһ */    
//             if(--hM4G_FSM.retryCnt == 0)
//             {
//                 hM4G_FSM.eTimeStat = TimeOut_ON;
//             }
//         }
//     }
// }


//FSM ͸״̬
static void M4G_FSM_DataPassThrough(void)
{
    uint32_t currTick = tls_os_get_time();
    if(hM4G_FSM.TxRxStat == TX_RX_STAT_IDLE)
    {
        TCP_SVR_SendHandler();
        TCP_SVR_FSM_Handler();

        hM4G_FSM.TxRxStat = TX_RX_STAT_BUSY;
    }
    else if(hM4G_FSM.TxRxStat == TX_RX_STAT_BUSY)
    {
        if(TCP_RecvPassThrough() == 1) //ַܵ
        {
            hM4G_FSM.tickStart = tls_os_get_time(); //յʱ
            TCP_SVR_RecvHandler(); //ݴ
            //memset(g_TCP_Rx_Buf,0,256);
        }
        else if((currTick - hM4G_FSM.tickStart) > pd4GMS_TO_TICKS(ConnectTick)) //ʱδյ
        {
            hM4G_FSM.TxRxStat  = TX_RX_STAT_IDLE;
            hM4G_FSM.txStep    = AT_DESTROY;
            hM4G_FSM.eCurrStat = M4G_STAT_DATA_BREAK_THROUGH;
            hM4G_FSM.retryCnt  = M4G_CMD_LIST[hM4G_FSM.txStep].retryNum;
            hM4G_FSM.rxTimeout = M4G_CMD_LIST[hM4G_FSM.txStep].TimeOut;
            netIF_SetOption_SvrState(0); //״̬
            printf("M4G disconnect\r\n");
        }
        hM4G_FSM.TxRxStat = TX_RX_STAT_IDLE;
    }
    M4G_AT_CMD_Recv(0);
}

//FSM ƽ̨״̬
static uint8_t M4G_FSM_BreakConnect(void)
{
    uint32_t currTick = tls_os_get_time();
    if(hM4G_FSM.TxRxStat == TX_RX_STAT_IDLE)
    {
        if(hM4G_FSM.retryCnt == 0)
        {
            if(++hM4G_FSM.txStep > AT_QIDEACT_ID)
            {
                printf("txStep Out -> Power OFF\r\n");
                /* жǷҪۼʱ䣨ԭǳʱƽ̨ߣ */
                if(hM4G_FSM.eTimeStat == TimeOut_ON)
                {
                    /* ʼ */
                    NET_M4G_Reset();    //ʱδظģ磬³ʼ
                    hM4G_FSM.eTimeStat = TimeOut_ON;
                }
                else
                {
                    NET_M4G_Reset();    //ʱδظģ磬³ʼ
                }
                hM4G_FSM.eCurrStat = M4G_STAT_CONNECT_RESTART;
                return 0;
            }
            /* װԴͳʱʱ */
            hM4G_FSM.retryCnt  = M4G_CMD_LIST[hM4G_FSM.txStep].retryNum;
            hM4G_FSM.rxTimeout = M4G_CMD_LIST[hM4G_FSM.txStep].TimeOut;
        } 
        M4G_AT_CMD_Send(hM4G_FSM.txStep);
        printf("Tx_Cmd:%s",M4G_CMD_LIST[hM4G_FSM.txStep].pATSendStr);//

        hM4G_FSM.TxRxStat  = TX_RX_STAT_BUSY;
        hM4G_FSM.tickStart = tls_os_get_time();
    }
    else
    {
        if(M4G_AT_CMD_Recv(hM4G_FSM.txStep) == 1)
        {
            hM4G_FSM.TxRxStat = TX_RX_STAT_IDLE;
            /* յָݣһν Դ */
            hM4G_FSM.retryCnt = 0;
        }
        else if((currTick - hM4G_FSM.tickStart) >= pd4GMS_TO_TICKS(hM4G_FSM.rxTimeout))
        {
            hM4G_FSM.TxRxStat = TX_RX_STAT_IDLE;
            /* ճʱԴһ */
            hM4G_FSM.retryCnt--;
        }
    }
    return 0;
}


static void M4G_FSM_Handler(void)
{
    switch (hM4G_FSM.eCurrStat)
    {
        case M4G_STAT_CONNECT_RESTART:
            M4G_FSM_RestartConnect();
            break;
        case M4G_STAT_CONNECT_START:
            M4G_FSM_StartConnect();
            break;
        case M4G_STAT_CONNECT_BASE_STATION:
            M4G_FSM_ConnectBaseStation();
            break;
        case M4G_STAT_HTTPS_CFG:
            M4G_FSM_ConnectHTTPSCfg();
            break;
        case M4G_STAT_HTTPS_ACTIVE:
            M4G_FSM_M4G_HTTPS_ACTIVE ();
            break;
        case M4G_STAT_CONNECT_PLATFORM:
            M4G_FSM_ConnectPlatform();
            break;
        case M4G_STAT_DATA_PASS_THROUGH:
            M4G_FSM_DataPassThrough();
            break;
        case M4G_STAT_DATA_BREAK_THROUGH:
            M4G_FSM_BreakConnect();
        default:
            break;
    }
}
/************************************************4G FSM FUNC END***********************************************************/

//M4G
void NET_M4G_Reset(void)
{
    AppM4G_Init();      //ӲλM4G
    TCP_SVR_FSM_Init(); //ʼ״̬
    netIF_SetOption_SvrState(0);
}


//ʼ
void AppM4G_Init(void)
{
    BSP_GPIO_Init(&hgpio1);
    AppCAT1_Init();//ڳʼ
    /* Ӳӿ */
    BSP_GPIO_Output_OFF(&hgpio1); //
    // M4G_UartHandle_Init();

    /* ݳʼ */
    M4G_FSM_Init();

    /* гʼ *///ģҪдгʼ
}


//
void AppM4G_Task(void)
{
    while(1)
    {	
        M4G_FSM_Handler();
    }
}

//4GźǿȻȡ
void M4G_GetSignalStrength(void)
{
    char aStrBuf[32]; 
    if(sdf_strmid((char *)huartx.pRxBuf, "+CSQ: ", ",", aStrBuf) != 0)
    {
        __OS_SHM_LOCK();
        g_tAppEc801.csq = atoi(aStrBuf);
        printf("CSQ:%d\r\n", g_tAppEc801.csq);
        __OS_SHM_UNLOCK();
       // lockȫźǿlockIF_SetOption(0, eCHG_IF_NET_CSQ, &g_tAppEc600.csq, 1);
    }
}



//TCPߴ
uint8_t TCP_RecvPassThrough(void)
{
    if(huartx.rxFlag == 1)
    {
        huartx.rxFlag = 0;
        if(M4G_AT_CMD_Recv(AT_DEOPEN) == 1) //յϢ
        {
            //״̬ת
            hM4G_FSM.txStep = AT_QICLOSE_ID;
            hM4G_FSM.eCurrStat = M4G_STAT_DATA_BREAK_THROUGH;
            hM4G_FSM.retryCnt  = M4G_CMD_LIST[hM4G_FSM.txStep].retryNum;
            hM4G_FSM.rxTimeout = M4G_CMD_LIST[hM4G_FSM.txStep].TimeOut;

            // printf_info("M4G_RxBuf = %s\r\n",huartx.pRxBuf);
            netIF_SetOption_SvrState(0);
            printf("M4G disconnect\r\n");
            return 0;
        }
        return 1;
    }
    return 0;
}
//Ϣӡ
void TCP_Read_Buff(uint8_t *buf)
{
    sdf_hex2str(buf,g_DBG_ascBuf,huartx.rxLen);
    printf("->Recv message:%.*s\r\n", huartx.rxLen * 2, g_DBG_ascBuf);
}


//Ϣӡ
void TCP_Write_bUFF(uint8_t *buf, uint32_t len)
{
    sdf_hex2str(buf,g_DBG_ascBuf,len);
    printf("->Send message:%.*s\r\n", len * 2, g_DBG_ascBuf);
    M4G_UART_Transmit(buf, len);
}


//ƽ̨
void EC600_Connet_TCP(void)
{
    uint8_t tempBuff[64] = {0};
    char netBuff[66] = {0};

    char userName[128] = {0};
    char passWord[128] = {0};
    char clientID[128] = {0};
    uint16_t netPort = 0;
    char *host = "1cd5afe936.st1.iotda-device.cn-north-4.myhuaweicloud.com";
    char *username = "67bd6b3624d7723255205068_test1";
    char *pwd = "779d2fe44f5e1d8e4cc34af27fbefdaa9bf644fb8fa7f85905dcc18b431d7f16";
    char *clientid = "67bd6b3624d7723255205068_test1_0_0_2025022508";
    memcpy(netBuff, host, strlen(host));
    memcpy(userName, username, strlen(username));
    memcpy(passWord, pwd, strlen(pwd));
    memcpy(clientID, clientid, strlen(clientid));
    // bkpIF_GetOption(eBKP_IF_FRAM_SVR_PORT, tempBuff, 2);
    netPort = 1883;
    // if(g_M4GserMode==1)
    // {
    //     // bkpIF_GetOption(eBKP_IF_FRAM_DOMAIN, tempBuff, 64);
    //     sprintf(netBuff, "%s", tempBuff);
    // }
    // else
    // {
    //     // bkpIF_GetOption(eBKP_IF_FRAM_SVR_IP, tempBuff, 4); //ģȡȫֱipmqttӿ
    //     sprintf(netBuff, "%d.%d.%d.%d", tempBuff[0], tempBuff[1], tempBuff[2], tempBuff[3]);
    // }
    if(hM4G_FSM.txStep == AT_QMTOPEN)
    {
        MQTT_Open_Step(0, netBuff, netPort);
    }
    if(hM4G_FSM.txStep == AT_QMTCONN)
    {
        MQTT_Establish_Step(0, clientID, userName, passWord);
    }
}


//MQTTӷ
void EC801_Connet_MQTT(void)
{


}

static s16 my_uart_rx_callback(u16 len, void* user_data) 
{
    huartx.rx_data_len += len;
    if (huartx.rx_msg_num < 3)
    {
        huartx.rx_msg_num++;
        tls_os_queue_send(huartx.demo_uart_q, (void *) DEMO_MSG_UART_RECEIVE_DATA, 0);
    }

    return WM_SUCCESS;
}


void App4G_PowerInit(void)
{
    BSP_GPIO_Init(&hgpio1);
    BSP_GPIO_Output_ON(&hgpio1);
}


void AppCAT1_Init(void)
{
    // App4G_PowerInit();

    tls_uart_options_t opt;
	opt.baudrate = UART_BAUDRATE_B115200 ; //
	opt.paritytype = TLS_UART_PMODE_DISABLED; //żУ
	opt.stopbits = TLS_UART_ONE_STOPBITS; //һֹͣλ
	opt.charlength = TLS_UART_CHSIZE_8BIT; //ݳ
	opt.flow_ctrl = TLS_UART_FLOW_CTRL_NONE; //û
    //  wm_uart1_rx_config(WM_IO_PB_07);
	//  wm_uart1_tx_config(WM_IO_PB_06);
    wm_uart3_rx_config(WM_IO_PA_06);
	wm_uart3_tx_config(WM_IO_PA_05);
//    wm_uart3_rx_config(WM_IO_PA_06);
//	wm_uart3_tx_config(WM_IO_PA_05);
    //uart
	if (WM_SUCCESS != tls_uart_port_init(M4G_UART.huart, &opt, 0))
	{
		printf("uart1 init error\n");
	}
	//Ϊڰ󶨽ջص
	tls_uart_rx_callback_register((u16) M4G_UART.huart, (s16(*)(u16, void*))my_uart_rx_callback, (void*)&M4G_UART); 

}

char *catcmd = "AT\r\n";
void AppCAT1_Task(void)
{
    tls_os_queue_create(&(huartx.demo_uart_q), DEMO_QUEUE_SIZE);
    tls_os_task_create(NULL, NULL,
                       AppM4G_Task,
                       NULL,
                       (void *) demo_uart_task_stk, /** ջʼַ */
                       DEMO_UART_TAST_STK_SIZE*4,                         /** ջĴС     */
                       DEMO_UART_TASK_PRIO, 0);
}
